"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.MockContainer = exports.mm = void 0;
const mock = require("egg-mock");
const midway_bin_1 = require("midway-bin");
const path_1 = require("path");
/**
 * 只初始化app级别的container
 * agent相关的逻辑使用mm2.app
 * @param options 参数
 */
function mockContainer(options) {
    return new MockContainer(options);
}
const getDefaultFramework = () => midway_bin_1.resolveModule('midway') || midway_bin_1.resolveModule('midway-mirror');
exports.mm = Object.assign({}, mock, {
    container: mockContainer,
});
exports.mm.app = (options = {}) => {
    if (process.env.MIDWAY_BASE_DIR && !options.baseDir) {
        options.baseDir = process.env.MIDWAY_BASE_DIR;
    }
    if (process.env.MIDWAY_FRAMEWORK_PATH && !options.framework) {
        options.framework = process.env.MIDWAY_FRAMEWORK_PATH;
    }
    // @ts-ignore
    return mock.app(Object.assign({
        framework: options.framework || getDefaultFramework(),
        typescript: !!require.extensions['.ts'],
        plugins: {
            'midway-mock': {
                path: path_1.join(__dirname, '../')
            }
        }
    }, options));
};
exports.mm.cluster = (options = {}) => {
    if (process.env.MIDWAY_BASE_DIR && !options.baseDir) {
        options.baseDir = process.env.MIDWAY_BASE_DIR;
    }
    if (process.env.MIDWAY_FRAMEWORK_PATH && !options.framework) {
        options.framework = process.env.MIDWAY_FRAMEWORK_PATH;
    }
    // @ts-ignore
    return mock.cluster(Object.assign({
        framework: options.framework || getDefaultFramework(),
        typescript: !!require.extensions['.ts'],
        plugins: {
            'midway-mock': {
                path: path_1.join(__dirname, '../')
            }
        }
    }, options));
};
class MockContainer {
    constructor(options = {}) {
        this.app = exports.mm.app(options);
    }
    async ready() {
        await this.app.ready();
    }
    async getAsync(id) {
        return this.app.applicationContext.getAsync(id);
    }
    get(id) {
        return this.app.applicationContext.get(id);
    }
}
exports.MockContainer = MockContainer;
//# sourceMappingURL=mock.js.map